GNU bug report logs - #11536
23.4; frequent spurious auto-save while typing

Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.

Package: emacs; Reported by: Jim Paris <jim@HIDDEN>; dated Mon, 21 May 2012 21:24:02 UTC; Maintainer for emacs is bug-gnu-emacs@HIDDEN.
Did not alter fixed versions and reopened. Request was from Debbugs Internal Request <help-debbugs@HIDDEN> to internal_control <at> debbugs.gnu.org. Full text available.

Message received at 11536 <at> debbugs.gnu.org:


Received: (at 11536) by debbugs.gnu.org; 5 Nov 2012 02:38:40 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Nov 04 21:38:40 2012
Received: from localhost ([127.0.0.1]:49455 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1TVCaF-0007Mg-CU
	for submit <at> debbugs.gnu.org; Sun, 04 Nov 2012 21:38:40 -0500
Received: from mail-da0-f44.google.com ([209.85.210.44]:53433)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <seewhydee@HIDDEN>) id 1TVCaC-0007MY-DP
	for 11536 <at> debbugs.gnu.org; Sun, 04 Nov 2012 21:38:37 -0500
Received: by mail-da0-f44.google.com with SMTP id h15so2466299dan.3
	for <11536 <at> debbugs.gnu.org>; Sun, 04 Nov 2012 18:35:32 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20120113;
	h=sender:from:to:cc:subject:references:date:in-reply-to:message-id
	:user-agent:mime-version:content-type;
	bh=yyPkRRRzeJc15B1KXCLm+Af19NpLh6LQITmQ+7bePe0=;
	b=ZAmZ7B0A4Bx77zh6kZ9UuMWfq0mzlDmYhdfGlIVjfWOyeBWfX3kN5gKR6iS2OYJYel
	2gFTSnpWRp/IIOYPqW8FozJW8+kwYmiIxqXcCj9PeaR355vOi6iCieyCftRHdhQTHvSJ
	rX+IJ9f7bzNy6B2ASjdf/4PhsK3b2iu0Sb5bGdUs7UN/BGRqsF0n9s4XOQSkMGHyxHhm
	w9WCgC6ysMQ24KbCN7XueH2Bx3tB0Yj/hVavvVdzxXaLHypHfQlBZtvYsVnyZKKJbCJv
	wfBSeMmacdugpjD55NglyE9E4GGeG/8W0337DUcdcAQErPTiMIj4L6KTsw/xyW/lKnza
	Fn6Q==
Received: by 10.68.83.68 with SMTP id o4mr26841727pby.25.1352082932315;
	Sun, 04 Nov 2012 18:35:32 -0800 (PST)
Received: from ulysses ([155.69.16.255])
	by mx.google.com with ESMTPS id sy1sm9722218pbc.66.2012.11.04.18.35.28
	(version=SSLv3 cipher=OTHER); Sun, 04 Nov 2012 18:35:31 -0800 (PST)
From: Chong Yidong <cyd@HIDDEN>
To: "Herbert J. Skuhra" <hskuhra@HIDDEN>
Subject: Re: [Emacs-diffs] /srv/bzr/emacs/trunk r110781: Fix a race condition
	in wait_reading_process_output (tiny change).
References: <E1TUgPO-0004i9-Iq@HIDDEN>
	<86objdhreu.wl%hskuhra@HIDDEN>
Date: Mon, 05 Nov 2012 10:35:24 +0800
In-Reply-To: <86objdhreu.wl%hskuhra@HIDDEN> (Herbert J. Skuhra's message of
	"Mon, 05 Nov 2012 00:36:25 +0100")
Message-ID: <87ehk8epzn.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/24.2.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: 0.1 (/)
X-Debbugs-Envelope-To: 11536
Cc: Jim Paris <jim@HIDDEN>, 11536 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.13
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -2.6 (--)

"Herbert J. Skuhra" <hskuhra@HIDDEN> writes:

> the changes in r110781 (and r110782) make Emacs hang on both Arch
> GNU/Linux (i686) and FreeBSD 9.1-PRERELEASE (i386), e.g: 
> when Wanderlust is checking IMAP4 mailboxes.
>
> Strace on GNU/Linux is showing a loop of:
>
> poll([{fd=5, events=POLLIN}, {fd=6, events=POLLIN}, {fd=7,
> events=POLLIN}, {fd=3, events=POLLIN}], 4, 0) = 0 (Timeout)
> pselect6(13, [12], [], NULL, {0, 0}, {NULL, 8}) = 0 (Timeout)
> clock_gettime(CLOCK_REALTIME, {1352071692, 886361097}) = 0
> clock_gettime(CLOCK_REALTIME, {1352071692, 886549522}) = 0
> recv(6, 0x887ea58, 4096, 0) = -1 EAGAIN (Resource temporarily
> unavailable)
>
> Ktrace on FreeBSD is showing a loop of:
>
> 11723 emacs-24.3.50 RET   poll 0
> 11723 emacs-24.3.50 CALL  pselect(0x13,0xbfbf98bc,0xbfbf983c,0,0xbfbf99f8,0)
> 11723 emacs-24.3.50 RET   pselect 0
> 11723 emacs-24.3.50 CALL  read(0x3,0x849a018,0x1000)
> 11723 emacs-24.3.50 RET   read -1 errno 35 Resource temporarily unavailable

OK.  I'm reverting the change and reopening Bug#11536.





Information forwarded to bug-gnu-emacs@HIDDEN:
bug#11536; Package emacs. Full text available.
bug closed, send any further explanations to 11536 <at> debbugs.gnu.org and Jim Paris <jim@HIDDEN> Request was from Chong Yidong <cyd@HIDDEN> to control <at> debbugs.gnu.org. Full text available.

Message received at 11536 <at> debbugs.gnu.org:


Received: (at 11536) by debbugs.gnu.org; 3 Nov 2012 15:49:40 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Nov 03 11:49:39 2012
Received: from localhost ([127.0.0.1]:47317 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1TUfyd-0001Oh-3o
	for submit <at> debbugs.gnu.org; Sat, 03 Nov 2012 11:49:39 -0400
Received: from mail-da0-f44.google.com ([209.85.210.44]:53951)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <seewhydee@HIDDEN>) id 1TUfya-0001Oa-VG
	for 11536 <at> debbugs.gnu.org; Sat, 03 Nov 2012 11:49:37 -0400
Received: by mail-da0-f44.google.com with SMTP id h15so2047542dan.3
	for <11536 <at> debbugs.gnu.org>; Sat, 03 Nov 2012 08:46:41 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20120113;
	h=sender:from:to:cc:subject:references:date:in-reply-to:message-id
	:user-agent:mime-version:content-type;
	bh=VKuV3FHZijXOqyPegMRuqSW6nRt9Gx43dFCZCh+ueUo=;
	b=XvxNWbk7h0U6wJ986kFeqKj9PmbUpCkc68un4zyqPujFNBWACHa1d7eWXM/n9azdfw
	FC6pBf9+PxxBgc8C2jtTSOxZ91gK1VrHr0BQx1QNmAAzkXjjrF8UFYEDJkJbdmxZdz91
	9Xv2ILizuTzP839mGPBTHa6TA6fgcZUG2wG/Hq+Y+ultMC3ELpcNC7QvnKn8gV77ryby
	w3jP9HxUozAXVWlOG77FUTyXcCd3VGgCrQVn1m2YICc4z3rKlVZoLOxnEVk/9qxbTdU4
	pSLKWmAUPjA56LOJ/tkL5NnD+sEeOADAfP00C2MjmXJ6obv7BarGP9oS1O02il/NnPwe
	sGig==
Received: by 10.68.202.41 with SMTP id kf9mr16158636pbc.56.1351957601599;
	Sat, 03 Nov 2012 08:46:41 -0700 (PDT)
Received: from ulysses (cm198.gamma83.maxonline.com.sg. [202.156.83.198])
	by mx.google.com with ESMTPS id ay5sm7561547pab.1.2012.11.03.08.46.38
	(version=SSLv3 cipher=OTHER); Sat, 03 Nov 2012 08:46:40 -0700 (PDT)
From: Chong Yidong <cyd@HIDDEN>
To: Jim Paris <jim@HIDDEN>
Subject: Re: bug#11536: 23.4; frequent spurious auto-save while typing
References: <20120521212217.GA29282@HIDDEN>
Date: Sat, 03 Nov 2012 23:46:36 +0800
In-Reply-To: <20120521212217.GA29282@HIDDEN> (Jim Paris's message of
	"Mon, 21 May 2012 17:22:17 -0400")
Message-ID: <87d2zupu3n.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/24.2.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: 0.1 (/)
X-Debbugs-Envelope-To: 11536
Cc: 11536 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.13
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: 0.1 (/)

Jim Paris <jim@HIDDEN> writes:

> The call to keyboard.c:set_waiting_for_input is essentially telling the
> keyboard.c:input_available_signal handler to reset &timeout to zero in
> the case of SIGIO.  However, consider what happens if a key is pressed
> and SIGIO is received between set_waiting_for_input and select.
> Then timeout will have been set to zero, and select will return
> immediately with nfds == 0.  The check in 5007 will then break the
> while loop, causing wait_reading_process_output to return immediately
> without any data having been read -- triggering the auto-save back
> in keyboard.c:read_char.
>
> It seems the fix is simple: remove lines 5007-5009.  It's a small
> optimization that isn't necessary, because the later check at line 5129
> already covers the case where nfds == 0.  Continuing the loop is fine,
> because the top of the loop checks for an expired timeout and returns.

Thanks for the bug report and the analysis.  I couldn't reproduce the
problem, but off the top of my head the analysis is correct, so I've
made the change you suggested in trunk.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#11536; Package emacs. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 21 May 2012 21:23:17 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon May 21 17:23:17 2012
Received: from localhost ([127.0.0.1]:37705 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1SWa4S-0001ck-FF
	for submit <at> debbugs.gnu.org; Mon, 21 May 2012 17:23:17 -0400
Received: from eggs.gnu.org ([208.118.235.92]:49957)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <jim@HIDDEN>) id 1SWa4P-0001cX-NH
	for submit <at> debbugs.gnu.org; Mon, 21 May 2012 17:23:15 -0400
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
	(envelope-from <jim@HIDDEN>) id 1SWa3e-00075v-NZ
	for submit <at> debbugs.gnu.org; Mon, 21 May 2012 17:22:28 -0400
X-Spam-Checker-Version: SpamAssassin 3.3.2 (2011-06-06) on eggs.gnu.org
X-Spam-Level: 
X-Spam-Status: No, score=-6.9 required=5.0 tests=BAYES_00,RCVD_IN_DNSWL_HI
	autolearn=unavailable version=3.3.2
Received: from lists.gnu.org ([208.118.235.17]:37374)
	by eggs.gnu.org with esmtp (Exim 4.71) (envelope-from <jim@HIDDEN>)
	id 1SWa3e-00075n-K3
	for submit <at> debbugs.gnu.org; Mon, 21 May 2012 17:22:26 -0400
Received: from eggs.gnu.org ([208.118.235.92]:49647)
	by lists.gnu.org with esmtp (Exim 4.71) (envelope-from <jim@HIDDEN>)
	id 1SWa3c-0008Bd-49
	for bug-gnu-emacs@HIDDEN; Mon, 21 May 2012 17:22:26 -0400
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
	(envelope-from <jim@HIDDEN>) id 1SWa3Z-00074c-Ju
	for bug-gnu-emacs@HIDDEN; Mon, 21 May 2012 17:22:23 -0400
Received: from jim.sh ([75.150.123.25]:59182 helo=psychosis.jim.sh)
	by eggs.gnu.org with esmtp (Exim 4.71) (envelope-from <jim@HIDDEN>)
	id 1SWa3Z-00071P-EN
	for bug-gnu-emacs@HIDDEN; Mon, 21 May 2012 17:22:21 -0400
Received: from psychosis.jim.sh (localhost [127.0.0.1])
	by psychosis.jim.sh (8.14.4/8.14.4/Debian-2) with ESMTP id
	q4LLMH03029408
	(version=TLSv1/SSLv3 cipher=DHE-RSA-AES256-SHA bits=256 verify=NO)
	for <bug-gnu-emacs@HIDDEN>; Mon, 21 May 2012 17:22:17 -0400
Received: (from jim@localhost)
	by psychosis.jim.sh (8.14.4/8.14.4/Submit) id q4LLMHO3029403
	for bug-gnu-emacs@HIDDEN; Mon, 21 May 2012 17:22:17 -0400
Date: Mon, 21 May 2012 17:22:17 -0400
From: Jim Paris <jim@HIDDEN>
To: bug-gnu-emacs@HIDDEN
Subject: 23.4; frequent spurious auto-save while typing
Message-ID: <20120521212217.GA29282@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain; charset=us-ascii
Content-Disposition: inline
User-Agent: Mutt/1.5.20 (2009-06-14)
X-Virus-Scanned: clamav-milter 0.97.3 at psychosis
X-Virus-Status: Clean
X-detected-operating-system: by eggs.gnu.org: Genre and OS details not
	recognized.
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.6 (newer, 3)
X-Received-From: 208.118.235.17
X-Spam-Score: -6.9 (------)
X-Debbugs-Envelope-To: submit
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.13
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -6.9 (------)

Hi,

I've had a recurring problem with various versions of emacs over the
years: as I type into a buffer, "Auto-saving...done" flashes repeatedly
in the minibuffer.  On some systems, it happens every few characters
that I type, while on other systems, it is less frequent (but still more
frequent than my auto-save-interval of 300 characters, or my
auto-save-timeout value of 30 seconds).

Setting auto-save-timeout to 0 makes the problem go away, so it is a
problem with the measuring of elapsed time.

I'm running "emacs -nw" in an xterm, and the frequency of the problem
has always varied quite a bit with my version of X server, Linux kernel,
emacs, etc, so I've long suspected that there is a race condition.  The
way I usually reproduce it is:
- run xterm
- run "emacs -nw foo.txt"
- hold down a key and notice how you see "auto-save" flashing
  occasionally even though you haven't hit 300 characters or been idle
  for 30 seconds.

I finally got around to looking for the bug, and think I may have
tracked it down as follows: (I'm unfamiliar with the emacs code, so
please forgive me if I'm stating the obvious or get something wrong)

Auto-save due to timeout interval is controlled by keyboard.c:read_char.
read_char calls dispnew.c:sit_for with the auto_save_timeout of e.g. 30
seconds.  If sit_for returns Qt (no input pending), then the autosave
happens.

sit_for works by calling process.c:wait_reading_process_output with the
same timeout.  After wait_reading_process_output returns, it returns
Qt if no input was pending.

So the auto-save problem that I'm seeing would occur if:
  - wait_reading_process_output returns before the timeout has expired
  - no input was received

I believe that this happens due to a race condition with SIGIO delivery
inside wait_reading_process_output, as follows.  Line numbers are from
process.c in debian's emacs23-23.4+1.  The pseudocode is roughly:

4707: while(1)
4737:    set &timeout to the remaining timeout
4739:    if time expired, break
4811:    set_waiting_for_input(&timeout)
4986:    select(..., &timeout)
5007:    if (time_limit && nfds == 0 && ! timeout_reduced_for_timers)
5008:      /* We wanted the full specified time, so return now.  */
5009:      break;
5010:    if (nfds < 0)
5011:      ...
5129:    if (no_avail || nfds == 0)
5130:      continue;

(I think the comment in 5008 is a typo and meant "We _waited_...")

The call to keyboard.c:set_waiting_for_input is essentially telling the
keyboard.c:input_available_signal handler to reset &timeout to zero in
the case of SIGIO.  However, consider what happens if a key is pressed
and SIGIO is received between set_waiting_for_input and select.
Then timeout will have been set to zero, and select will return
immediately with nfds == 0.  The check in 5007 will then break the
while loop, causing wait_reading_process_output to return immediately
without any data having been read -- triggering the auto-save back
in keyboard.c:read_char.

I've verified with systemtap that select() is indeed being called with a
timeout of 0, so I'm pretty sure that this is the problem.

It seems the fix is simple: remove lines 5007-5009.  It's a small
optimization that isn't necessary, because the later check at line 5129
already covers the case where nfds == 0.  Continuing the loop is fine,
because the top of the loop checks for an expired timeout and returns.
Alternately, the "break" in 5009 could be replaced with a "continue"
which would still go back up to double-check that the timeout was really
hit.

Removing the 5007-5009 check fixes the problem on all the systems I've
tried.

-jim

If Emacs crashed, and you have the Emacs process in the gdb debugger,
please include the output from the following gdb commands:
    `bt full' and `xbacktrace'.
For information about debugging Emacs, please read the file
/usr/share/emacs/23.4/etc/DEBUG.


In GNU Emacs 23.4.1 (x86_64-pc-linux-gnu, GTK+ Version 2.24.10)
 of 2012-04-07 on trouble, modified by Debian
configured using `configure  '--build' 'x86_64-linux-gnu' '--build' 'x86_64-linux-gnu' '--prefix=/usr' '--sharedstatedir=/var/lib' '--libexecdir=/usr/lib' '--localstatedir=/var/lib' '--infodir=/usr/share/info' '--mandir=/usr/share/man' '--with-pop=yes' '--enable-locallisppath=/etc/emacs23:/etc/emacs:/usr/local/share/emacs/23.4/site-lisp:/usr/local/share/emacs/site-lisp:/usr/share/emacs/23.4/site-lisp:/usr/share/emacs/site-lisp' '--with-crt-dir=/usr/lib/x86_64-linux-gnu' '--with-x=yes' '--with-x-toolkit=gtk' '--with-toolkit-scroll-bars' 'build_alias=x86_64-linux-gnu' 'CFLAGS=-g -O2 -fstack-protector --param=ssp-buffer-size=4 -Wformat -Wformat-security -Werror=format-security -Wall -DDEBIAN -O2' 'CPPFLAGS=-D_FORTIFY_SOURCE=2''

Important settings:
  value of $LC_ALL: nil
  value of $LC_COLLATE: nil
  value of $LC_CTYPE: en_US.UTF-8
  value of $LC_MESSAGES: en_US
  value of $LC_MONETARY: nil
  value of $LC_NUMERIC: nil
  value of $LC_TIME: nil
  value of $LANG: POSIX
  value of $XMODIFIERS: nil
  locale-coding-system: utf-8-unix
  default enable-multibyte-characters: t

Major mode: Text

Minor modes in effect:
  tooltip-mode: t
  mouse-wheel-mode: t
  tool-bar-mode: t
  file-name-shadow-mode: t
  global-font-lock-mode: t
  font-lock-mode: t
  auto-encryption-mode: t
  auto-compression-mode: t
  column-number-mode: t
  line-number-mode: t
  transient-mark-mode: t

Recent input:
ESC x r e p o r t - e m a c s - b u g RET

Recent messages:
Loading /etc/emacs/site-start.d/50octave3.2-emacsen.el (source)...done
Loading /etc/emacs/site-start.d/50psvn.el (source)...done
Loading /etc/emacs/site-start.d/70jim.el (source)...
Toggling menu-bar-mode off; better pass an explicit argument.
Ready.
Loading /etc/emacs/site-start.d/70jim.el (source)...done
Loading quail/latin-ltx...done
Loading /home/jim/.emacs.d/systemtap-mode.el (source)...done
Ready.
call-interactively: Text is read-only

Load-path shadows:
/usr/share/emacs/23.4/site-lisp/cmake/cmake-mode hides /usr/share/emacs/23.4/site-lisp/cmake-data/cmake-mode
/usr/share/emacs/23.4/site-lisp/cmake/cmake-mode hides /usr/share/emacs/site-lisp/cmake-mode
/usr/share/emacs/23.4/site-lisp/debian-startup hides /usr/share/emacs/site-lisp/debian-startup
/usr/share/emacs23/site-lisp/dictionaries-common/flyspell hides /usr/share/emacs/23.4/lisp/textmodes/flyspell
/usr/share/emacs23/site-lisp/dictionaries-common/ispell hides /usr/share/emacs/23.4/lisp/textmodes/ispell
/usr/share/emacs/23.4/site-lisp/octave3.2-emacsen/octave-inf hides /usr/share/emacs/23.4/lisp/progmodes/octave-inf
/usr/share/emacs/23.4/site-lisp/octave3.2-emacsen/octave-mod hides /usr/share/emacs/23.4/lisp/progmodes/octave-mod

Features:
(shadow sort mail-extr message sendmail ecomplete rfc822 mml mml-sec
password-cache mm-decode mm-bodies mm-encode mailcap mail-parse rfc2231
rfc2047 rfc2045 qp ietf-drums mailabbrev nnheader gnus-util netrc
time-date mm-util mail-prsvr gmm-utils wid-edit mailheader canlock sha1
hex-util hashcash mail-utils emacsbug systemtap-mode byte-opt bytecomp
byte-compile cc-awk cc-langs cl cl-19 cc-mode cc-fonts cc-menus cc-cmds
cc-styles cc-align cc-engine cc-vars cc-defs regexp-opt quail help-mode
easymenu view emacs-goodies-el emacs-goodies-custom
emacs-goodies-loaddefs easy-mmode tooltip ediff-hook vc-hooks
lisp-float-type mwheel x-win x-dnd font-setting tool-bar dnd fontset
image fringe lisp-mode register page menu-bar rfn-eshadow timer select
scroll-bar mldrag mouse jit-lock font-lock syntax facemenu font-core
frame cham georgian utf-8-lang misc-lang vietnamese tibetan thai
tai-viet lao korean japanese hebrew greek romanian slovak czech european
ethiopic indian cyrillic chinese case-table epa-hook jka-cmpr-hook help
simple abbrev loaddefs button minibuffer faces cus-face files
text-properties overlay md5 base64 format env code-pages mule custom
widget hashtable-print-readable backquote make-network-process dbusbind
system-font-setting font-render-setting gtk x-toolkit x multi-tty emacs)




Acknowledgement sent to Jim Paris <jim@HIDDEN>:
New bug report received and forwarded. Copy sent to bug-gnu-emacs@HIDDEN. Full text available.
Report forwarded to bug-gnu-emacs@HIDDEN:
bug#11536; Package emacs. Full text available.
Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.
Last modified: Fri, 31 Oct 2014 17:00:04 UTC

GNU bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997 nCipher Corporation Ltd, 1994-97 Ian Jackson.